; Timo's maze solver adapted by ruud for the test-suites..


; Hugi Size Coding Competition #11 example program. See HC11 rules for
; detailed info about this compo.
;
; This program finds the shortest path through a maze using breadth first
; search.
;
; Don't laugh at me... I tried to grow the size a bit (I thought that
; ~170 bytes example might be a bit too small...)
; Going back to killing bytes... ;-)
;
; Compilation:  tasm -m9 example.asm
;               tlink -t -x example
;
; Note! This code is real ugly and intentionally made to be a bigger
;       then "normal" code. There's not much comment to say how
;       this works but maybe Jibzs C -code might (especially the BFS version)
;       might clarify things a bit.
;       If someone really needs more explanation about breadth first search
;       (s)he should ask me (or someone else) to explain it in eGroups.
;       I (Fabled) can be contacted via "fabled@iki.fi".
;
; ASCIIs stolen from TADs rules (thanx TAD).
;
; Good luck to all for HC11 !!
;
; -Fabled
;
;
; TAD: (thanx for the credits Fabled :)
; TAD: saves maze to the file: "THESEUS"
;

        Ideal
        P386
        Model Tiny
        

        CODESEG

        Org 100h


start:
        call    ChkEntry1     ;Run entry.com for test-suites
        mov     ax,[wEntryMoves]
        cmp	ax,-1
        jnz     GoOn
        mov     ax,4c01h       ;Error, !!!
        int     21h

GoOn:   mov     [wNopCount],0   ;Counter for test-suites.

        call    InitTables
        call    ReadMino
        call    Solve
        call    WriteTour
        mov     ax,[wNopCount]
        sub     ax,[wEntryMoves]
        mov     ah,4ch
        je      exit
        mov     al,2	;Not minimum path length
exit:   int     21h
exit3:  mov     ax,4c03h
        int     21h

InitTables:

        ;
        ; Initialize tables
        ;

        mov     di, offset queue
        mov     cx, 10000*2
        mov     ax, -1
        rep     stosw
        retn

ReadTour:
        mov     dx,offset outputfile
        jmp short Read1

ReadMino:
        mov     dx, offset inputfile

        ;
        ; Read in the maze
        ;

Read1:  
        mov     cx, 10001
        mov     ax, 03d00h
        int     21h
        jc short NoRead
        mov     [handle], ax

        mov     ah, 03fh
        mov     bx, [handle]
        cmp     dx,offset outputfile
        mov     dx, offset maze
        jnz short IsIn
        mov     dx, offset queue
IsIn:   int     21h
        mov     cx,ax

        mov     ah, 03eh
        mov     bx, [handle]
        int     21h
NoRead:
        retn

Solve:

        ;
        ; Find the BEGIN location from the maze
        ;

        mov     di, offset maze
        mov     cx, 10000
        mov     al, 2
        repne   scasb
        dec     di

        sub     di, offset maze         ; get offset from maze
        mov     si, di

        ;
        ; Do breadth first search
        ;  SI = queue head
        ;  DI = queue tail
        ;

bfs:
        lea     bp, [si-100]
        call    AddNode                 ; go up

        lea     bp, [si-1]
        call    AddNode                 ; go left

        lea     bp, [si+1]
        call    AddNode                 ; go right

        lea     bp, [si+100]
        call    AddNode                 ; go down

        add     si, si                  ; dequeue
        mov     si, [queue+si]          ; next position

        cmp     si, -1                  ; no solution?
        je      exit3                    
        cmp     [maze+si], 3            ; exit location?
        jne     bfs                     ; search until exit is found

        ; At this point the shortest path has been found.
        ; Now we have to "backtrack" and mark the optimal path.

        ;
        ; Reconstruct the solution
        ;

find:
        add     si, si
        mov     si, [previous+si]       ; get previous cell
        cmp     [maze+si], 1            ; beginning of maze?
        jne     done                    ; if yes then the path is marked
        mov     [maze+si], 90h          ; otherwise mark path
        inc     [wNopCount]
        jmp     find                    ; and advance
done:   retn


WriteTour:

        ;
        ; Write out the solution
        ;

        mov     ah, 03ch
        xor     cx, cx
;;        mov     dx, offset outputfile
	mov	dx, offset testfile
        int     21h
        mov     [handle], ax

        mov     ah, 040h
        mov     bx, [handle]
        mov     cx, 10000
        mov     dx, offset maze
        int     21h

        mov     ah, 03eh
        mov     bx, [handle]
        int     21h

        retn


AddNode:
        ; check that BP is within the maze

        cmp     bp, 10000
        jae     _ret

        ; check that [BP] is not WALL or BEGIN

        cmp     [maze+bp], 0
        je      _ret

        cmp     [maze+bp], 2
        je      _ret

        ; check that BP is not queued yet

        add     bp, bp
        cmp     [queue+bp], -1
        jne     _ret

        ; add position BP to end of queue
        ; and update travelling table

        mov     [previous+bp], si
        shr     bp, 1
        add     di, di
        mov     [queue+di], bp
        mov     di, bp

_ret:   retn

ChkEntry1:	pusha
	push	ds
	push	es
	mov	[wEntryMoves],-1
	mov	bx,1000h
	mov	ah,4ah
	int	21h	;Resize memory..
	mov	[wCs1],ax
	mov	[wCs2],ax
	mov	[wCs3],ax
	mov	si,82h
	mov	di,offset bFile
	mov	ax,20h
@@l00:	cmp	[si],al
	movsb
	jae	@@l00
	mov	[di-1],ah
        
	mov	dx,offset bFile
	mov	bx,offset bEpb
	mov	ax,4b00h
	int	21h	;Execute entry.com
	jc	Err1
	pop	es
	pop	ds
	call	ReadTour
	cmp	cx,10000	;Check file size
	jnz	Err1
	mov	di, offset queue
	cld
	mov	al,2
	repne scasb
	jnz	Err1
	xor	dx,dx
	dec	di
NextNop:	mov	bx,offset wTable1
NN0:	add	di,[bx]
	inc	bx
	inc	bx
	cmp	[byte ptr di],3
	je	PathOk
	cmp	[byte ptr di],90h
	je	RemNop
	cmp	[word ptr bx],0
	jne	NN0
	jmp short	Err1
RemNop:	inc	dx
	mov	[byte ptr di],1
	jmp	NextNop
PathOk:	push	dx
	call	ReadMino
	mov	cx,10000
	mov	si,offset queue
	mov	di,offset maze
	repe cmpsb
	pop	dx
	jne	Err1
	mov	[wEntryMoves],dx
Err1:	popa
	ret


        DATASEG

inputfile       db "MINO",0
outputfile      db "TOUR",0
testfile	db "THESEUS",0

wTable1 dw      1,99,-101,-99,0

bEpb    dw      0
        dw      80h
wCs1    dw      0
        dw      5ch
wCs2    dw      0
        dw      6ch
wCs3    dw      0
        dw      $-bEpb

handle          dw ?

wNopCount       dw ?
wEntryMoves     dw ?
bFile           db 40h dup (?)

; The maze

maze            db 10000 dup (?)

; Queue for processing each position

queue           dw 10000 dup (?)

; Travelling information
; This contains the position where we came from
; for each position in the maze

previous        dw 10000 dup (?)



        END start
